"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var inputSchema = require("../schema/inputSchema.json");

var assertingInputOK = function assertingInputOK(ajv, JsonValidationError, Promise) {
    var okRequest = ajv({}).compile(inputSchema);

    return function (requestDef) {
        return new Promise(function (resolve, reject) {
            return !okRequest(requestDef) ? reject(new JsonValidationError(okRequest.errors, "Input")) : resolve(true);
        });
    };
};

var injection = exports.injection = function injection(container) {
    return container.mapClass("assertingInputOK", assertingInputOK, true);
};

exports.default = assertingInputOK;