"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var assertingResponseOK = function assertingResponseOK(ajv, JsonValidationError) {
    var ajvRemoveAdditional = ajv({ removeAdditional: true });

    return function (link) {
        var responseOk = link.targetSchema ? ajvRemoveAdditional.compile(link.targetSchema) : function () {
            return true;
        };

        return function (data) {
            if (!responseOk(data)) {
                throw new JsonValidationError(responseOk.errors, "Response");
            }

            return data;
        };
    };
};

var injection = exports.injection = function injection(container) {
    return container.mapClass("assertingResponseOK", assertingResponseOK, true);
};

exports.default = assertingResponseOK;