"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var firingRequest = function firingRequest(fetch) {
    return function (builtRequest) {
        return fetch(builtRequest.url, builtRequest.request).then(function (response) {
            if (response.status >= 200 && response.status < 300) {
                return response;
            } else {
                var error = new Error(response.statusText);
                error.response = response;
                throw error;
            }
        }).then(function (response) {
            return response.json();
        }).then(function (parsed) {
            return parsed;
        });
    };
};

var injection = exports.injection = function injection(container) {
    return container.mapClass("firingRequest", firingRequest, true);
};

exports.default = firingRequest;