"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _ajv = require("ajv");

var _ajv2 = _interopRequireDefault(_ajv);

var _deepPluck = require("deep-pluck");

var _deepPluck2 = _interopRequireDefault(_deepPluck);

var _deref = require("deref");

var _deref2 = _interopRequireDefault(_deref);

var _isomorphicFetch = require("isomorphic-fetch");

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _es6Promise = require("es6-promise");

var _uriTemplates = require("uri-templates");

var _uriTemplates2 = _interopRequireDefault(_uriTemplates);

var _infuse = require("infuse.js");

var _formData = require("form-data");

var _formData2 = _interopRequireDefault(_formData);

var _array = require("array.from");

var _array2 = _interopRequireDefault(_array);

var _jsonSchemaLoadTree = require("json-schema-load-tree");

var _jsonSchemaLoadTree2 = _interopRequireDefault(_jsonSchemaLoadTree);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var container = new _infuse.Injector();

// add external modules to DI container
(function (items) {
    return Object.keys(items).forEach(function (key) {
        return container.mapValue(key, items[key]);
    });
})({
    ajv: _ajv2.default,
    deepPluck: _deepPluck2.default,
    deref: _deref2.default,
    fetch: _isomorphicFetch2.default,
    FormData: _formData2.default,
    from: _array2.default,
    jsonSchemaLoadTree: _jsonSchemaLoadTree2.default,
    Promise: _es6Promise.Promise,
    uriTemplates: _uriTemplates2.default
});

// Load our stuff in
require("./assertingInputOK").injection(container);
require("./assertingResponseOK").injection(container);
require("./composeRequest").injection(container);
require("./escapeUrl").injection(container);
require("./firingRequest").injection(container);
require("./jsonSchemaRequest").injection(container);
require("./jsonValidationError").injection(container);
require("./matchLink").injection(container);
require("./resolveDataForInspection").injection(container);
require("./resolveDataForTransmission").injection(container);
require("./resolveUrl").injection(container);

// infuse!

exports.default = function () {
    return container.getValue("jsonSchemaRequest");
};