"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var jsonSchemaRequest = function jsonSchemaRequest(assertingInputOK, assertingResponseOK, composeRequest, deref, firingRequest, jsonSchemaLoadTree, matchLink) {
    return function (requestDef) {
        return assertingInputOK(requestDef).then(function () {
            return jsonSchemaLoadTree(requestDef.schemaUrl);
        }).then(function (tree) {
            return deref()(requestDef.schemaPrefix, tree[requestDef.schemaUrl], Object.keys(tree).map(function (key) {
                return tree[key];
            }), true);
        }).then(matchLink(requestDef)).then(function (link) {
            return firingRequest(composeRequest(requestDef)(link)).then(assertingResponseOK(link));
        });
    };
};

var injection = exports.injection = function injection(container) {
    return container.mapClass("jsonSchemaRequest", jsonSchemaRequest, true);
};

exports.default = jsonSchemaRequest;