"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var JsonValidationError = function (_Error) {
    _inherits(JsonValidationError, _Error);

    function JsonValidationError(errors, source) {
        _classCallCheck(this, JsonValidationError);

        if (!Array.isArray(errors)) {
            errors = [errors];
        }

        var message = errors.map(function (err) {
            return (err.dataPath || JSON.stringify(err.params || {})) + " " + err.message;
        }).join("; ");

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(JsonValidationError).call(this, source + ": " + message));

        _this.errors = errors;
        _this.status = 500;
        return _this;
    }

    return JsonValidationError;
}(Error);

var injection = exports.injection = function injection(container) {
    return container.mapValue("JsonValidationError", JsonValidationError);
};

exports.default = JsonValidationError;