"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var matchLink = function matchLink(requestDef) {
    return function (schema) {
        // will need access to requestDef
        if (!Array.isArray(schema.links) || schema.links.length === 0) {
            throw new Error("Schema has no links, cannot create a request.");
        }
        var matchingLinks = schema.links.filter(function (link) {
            return link.rel === requestDef.rel;
        });

        if (matchingLinks.length === 0) {
            throw new Error("Could not find a link matching the given rel '" + requestDef.rel + "' for " + requestDef.schemaUrl);
        } else if (matchingLinks.length > 1) {
            throw new Error("Found multiple links with the same rel!");
        } else {
            var _ret = function () {

                var alreadySeeked = [];

                var seekRefs = function seekRefs(obj) {
                    if (alreadySeeked.indexOf(obj) > -1) {
                        return obj;
                    }
                    if ((typeof obj === "undefined" ? "undefined" : _typeof(obj)) !== "object") return obj;
                    if (Array.isArray(obj)) return obj.map(seekRefs);

                    Object.keys(obj).forEach(function (key) {
                        return obj[key] = seekRefs(obj[key]);
                    });

                    if (obj["$ref"] === schema.id + "#") {
                        delete obj["$ref"];
                        var schemaClone = _extends({}, schema);
                        delete schemaClone.links;
                        var newObj = _extends({}, obj, schemaClone);
                        obj = newObj;
                    }

                    alreadySeeked.push(obj);

                    return obj;
                };

                return {
                    v: seekRefs(matchingLinks[0])
                };
            }();

            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
        }
    };
};

var injection = exports.injection = function injection(container) {
    return container.mapValue("matchLink", matchLink);
};

exports.default = matchLink;