"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var resolveDataForTransmission = function resolveDataForTransmission(FormData) {
    return function (inputData) {
        if (typeof inputData === "string" || inputData instanceof FormData) {
            return inputData;
        } else if (typeof inputData === "function") {
            throw new TypeError("Expected a string or object, received a function");
        } else {
            return JSON.stringify(inputData);
        }
    };
};

var injection = exports.injection = function injection(container) {
    return container.mapClass("resolveDataForTransmission", resolveDataForTransmission, true);
};

exports.default = resolveDataForTransmission;